#include<dirent.h>
#include<errno.h>
#include<sys/types.h>
#include<sys/stat.h>

int CursX,CursY,TxtCol,b;
unsigned char avt_color=FALSE,avt_rep=FALSE,avt_command=FALSE,c,cc;
unsigned char pcb_color=FALSE,pcb_code=FALSE,d,pcb_col=0;
unsigned char ans_esc=FALSE,ans_code=FALSE,ans_rep,e,ans_attr=0;
unsigned char sync_code=FALSE;
int acx,acy,errno;
char ansicode[20];
char copytmp[20];
char code[20];
char *copy(char *str,int aa,int bb) {
   int x;
   sprintf(copytmp,"  "); 
   for (x=aa;x<=bb;x++) {
      copytmp[x-aa]=str[x];
   }  
   return copytmp;
}


unsigned char display_ansi(char ch) {
   int x,y,a=0,b;
   if (ans_rep>0) {
      ans_rep--;
      if (ans_rep==0) return 0;
      return 20;
   }
   if ((ans_esc==TRUE)&(ch=='[')) {
      ans_esc=FALSE;
      ans_code=TRUE;
      return 0;
   } else ans_esc=FALSE;
   if (ans_code==TRUE) {
      ans_code=FALSE;
      switch (ch) {
        case 'm': 
	 ans_attr=TxtCol;
	 a=0;
	 for (x=0;x<strlen(ansicode);x++) 
	   if ((ansicode[x]>='0')|(ansicode[x]<='9')){
	      b=0;
	      code[b++]=ansicode[x];
	      if ((ansicode[x+1]>='0')&(ansicode[x+1]<='9'))
		code[b++]=ansicode[++x];
	      code[b++]=0;
	      switch(strtol(code,NULL,0)) {
	       case 0 : 
		 ans_attr=7;
		 break;
	       case 1 :
		 ans_attr=(ans_attr&247)+8;
		 break;
	       case 5 :
		 ans_attr=(ans_attr&127)+128;
		 break;
	       case 30:
		 ans_attr=ans_attr&248;
		 break;
	       case 34:
		 ans_attr=(ans_attr&248)+1;
		 break;
	       case 32:
		 ans_attr=(ans_attr&248)+2;
		 break;
	       case 36:
		 ans_attr=(ans_attr&248)+3;
		 break;
	       case 31:
		 ans_attr=(ans_attr&248)+4;
		 break;
	       case 35:
		 ans_attr=(ans_attr&248)+5;
		 break;
	       case 33:
		 ans_attr=(ans_attr&248)+6;
		 break;
	       case 37:
		 ans_attr=(ans_attr&248)+7;
		 break;       
	       case 40:
		 ans_attr=ans_attr&143;
		 break;
	       case 44:
		 ans_attr=(ans_attr&143)+16; 
		 break;
	       case 42:
		 ans_attr=(ans_attr&143)+32;
		 break;
	       case 46:
		 ans_attr=(ans_attr&143)+48;
		 break;
	       case 41:
		 ans_attr=(ans_attr&143)+64;
		 break;
	       case 45:
		 ans_attr=(ans_attr&143)+80;
		 break;
	       case 43:
		 ans_attr=(ans_attr&143)+(6<<4);
		 break;
	       case 47:
		 ans_attr=(ans_attr&143)+(7<<4);
		 break;
	      }
	      a=x;
	      x++;
	   };
	 TxtCol=ans_attr;
	 return 0;
	 break;	 
       case 'H':
	 for (x=0;x<strlen(ansicode);x++) 
	   if (ansicode[x]==';') y=x;
	 CursY=strtol(copy(ansicode,0,y-1),NULL,0);
	 CursX=strtol(copy(ansicode,y+1,strlen(ansicode)-1),NULL,0);
/*	 move(0,0);
	 write("%s\n",ansicode);
	 write("%s : %d\n",copy(ansicode,0,y-1),CursY);
	 write("%s : %d\n",copy(ansicode,y+1,strlen(ansicode)-1),CursX);
	 ReadChar();*/
	 break;
       case 'C':
	 ans_rep=strtol(ansicode,NULL,0)+1;	 
	 return 0;
	 break;
       case 'A':
	 CursY--;
	 break;
       case 'S':
       case 's':
	 acx=CursX;
	 acy=CursY;
	 break;
       case 'U':
       case 'u':
	 CursX=acx;
	 CursY=acy;
	 break;
       case 'J':
	 CursX=0;
	 CursY=0;
	 break;
       default:
	 sprintf(ansicode,"%s%c",ansicode,ch);
	 ans_code=TRUE;
	 break;
      }
      return 0;
   }   
   switch (ch) {
    case '': 
      ans_code=FALSE;
      ans_esc=TRUE;
      ansicode[0]=0;
      return 0;
      break;
    default:
      return ch;
      break;
   }
   return 0;
}

unsigned char display_PCBoard(char ch) {
   char *c;
   if (pcb_color==TRUE) {   
      c=(char *)malloc(6);
      d++;
      if (d<3) {
	 switch (d) {
	  case 1:
	    sprintf(c,"0x%c",ch);
	    pcb_col=strtol(c,NULL,0)*16;
	    break;
	  case 2:
	    sprintf(c,"0x0%c",ch);
	    pcb_col+=strtol(c,NULL,0);
	    break;
	 }
	 free(c);
	 return 0;
      }
      TxtCol=pcb_col;
      pcb_color=FALSE;
      pcb_code=FALSE;
      return ch;
   }
   d=0;
   if (pcb_code==TRUE) {
      switch(ch){
       case '@':
	 pcb_code=FALSE;
	 break;
       case 'X':
	 pcb_color=TRUE;
	 break;
      }      
      return 0;
   }   
   switch (ch) {
    case '@': 
      pcb_code=TRUE;
      break;
    default:
      return ch;
      break;
   }
   return 0;
}

unsigned char display_avatar(unsigned char ch) {
   if (avt_rep==TRUE) {
      switch (b){
       case 1:
	 c=ch;
	 b=2;
	 return 0;
	 break;
       case 2:
	 cc=ch;
	 b=3;
	 return 0;
	 break;
       case 3:
	 cc--;
	 if (cc>0) return c;
	 break;
      }      
      avt_rep=FALSE;
   }
   b=0;
   if (avt_color==TRUE) {
      TxtCol=ch;
      avt_command=FALSE;
      avt_color=FALSE;
      return 0;
   }
   if (avt_command==TRUE) {
      switch (ch) {
       case 1:
	 avt_color=TRUE;
	 break;
       default:
	 avt_command=FALSE;
      }
      return 0;
   }
   switch (ch) {
    case '': 
      CursX=0;CursY=0;
      break;
    case '':
      avt_rep=TRUE;
      b=1;
      break;
    case '':
      avt_command=TRUE;
      break;
    case 10:
      CursX=0;
      CursY++;
      break;
    case 13:
      CursX=0;
      break;
    default:
      return ch;
      break;
   }
   return 0;
}

unsigned char display_sync (unsigned char ch)  {
    if(ch == 1)  {
    	sync_code=TRUE;
	return 0;
    }
    if(sync_code)  {
	switch(ch)  {
	    case 'L':  /* Clear Screen */
		 CursX=0;
		 CursY=0;
	    	 break;
	    case 'N':
		 ans_attr=7;
		 break;
	    case 'H':
		 ans_attr=(ans_attr&247)+8;
	    	 break;
	    case 'I':
		 ans_attr=(ans_attr&127)+128;
		 break;
	    case 'K':
		 ans_attr=ans_attr&248;
		 break;
	    case 'B':
		 ans_attr=(ans_attr&248)+1;
		 break;
	    case 'G':
		 ans_attr=(ans_attr&248)+2;
		 break;
	    case 'C':
		 ans_attr=(ans_attr&248)+3;
		 break;
	    case 'R':
		 ans_attr=(ans_attr&248)+4;
		 break;
	    case 'M':
		 ans_attr=(ans_attr&248)+5;
		 break;
	    case 'Y':
		 ans_attr=(ans_attr&248)+6;
		 break;
	    case 'W':
		 ans_attr=(ans_attr&248)+7;
		 break;       
	    case '0':
		 ans_attr=ans_attr&143;
		 break;
	    case '4':
		 ans_attr=(ans_attr&143)+16; 
		 break;
	    case '2':
		 ans_attr=(ans_attr&143)+32;
		 break;
	    case '6':
		 ans_attr=(ans_attr&143)+48;
		 break;
	    case '1':
		 ans_attr=(ans_attr&143)+64;
		 break;
	    case '5':
		 ans_attr=(ans_attr&143)+80;
		 break;
	    case '3':
		 ans_attr=(ans_attr&143)+(6<<4);
		 break;
	    case '7':
		 ans_attr=(ans_attr&143)+(7<<4);
		 break;
	}
	if(ch>126)  {
	     CursX+=ch-127;
	}
	TxtCol=ans_attr;
	sync_code=FALSE;
	return 0;
    }
    return ch;
}

void LoadFile(char *Name) {
   FILE *fp;
   int ch;
   erasescreen();
   fp=fopen(Name,"rb");
   CursX=0;CursY=0;TxtCol=7;
   LastLine=0;
   ch=strlen(Name)-3;
   if ((toupper(Name[ch++])=='B')&(toupper(Name[ch++])=='I')&(toupper(Name[ch])=='N')) {
      unsigned char line[160];
      do {
	 fread(&line,1,160,fp);
	 memcpy(Screen[ActivePage][CursY],&line,160);
	 CursY++;
      } while (!feof(fp));
   } else 
     do {
	ch=fgetc(fp);	
	if (ch==26&&avt_command==FALSE&&avt_rep==FALSE) break;
	do {
	   ch=display_PCBoard(display_ansi(display_sync(display_avatar(ch))));
	   if (ch>0){
	      if (CursX>79) {
		 CursX=0;
		 CursY++;
	      }	 
	      if (ans_rep==0) {
		 Screen[ActivePage][CursY][CursX*2]=ch;
		 Screen[ActivePage][CursY][(CursX*2)+1]=TxtCol;
	      }
	      CursX++;
	   }
	} while ((avt_rep==TRUE&&b==3)||(ans_rep>0));
     } while(!feof(fp));
   ReadSauce(fp);
   fclose(fp);
   LastLine=CursY;
}

void load() {
   char *dirs[2000],isdir[2000],*tmp;
   char titel[2000][28],paintrec[2000][18],grouprec[2000][15];
   static int num=0;
   int readnew=1;
   int x,y,z,ch,a;
   FILE *fp;
   SauceRecord Tmp;
   struct dirent *direntp;
   DIR *dirp;
   struct stat stats;
   
   clear();
   move(0,0);
   for (x=0;x<=1950;x++){
      TextColor(LoadAnsi[(x<<1)+1]);   
      if (LoadAnsi[x<<1]==0) LoadAnsi[x<<1]=32;
      writechar(LoadAnsi[x<<1]);
      if (COLS>80&&(x+1)%80==0) writechar('\n');
   }   
   do {
      if (readnew==1) {
	 z=0;y=0;
	 readnew=0;
	 for (a=1;a<=num;a++)
	   free(dirs[a]);
	 a=0;
	 num=0;
	 dirp=opendir(".");
	 direntp=readdir(dirp);
	 if (dirp!=NULL){
	    for (;;){
	       direntp=readdir(dirp);
	       if (direntp==NULL) break;
	       dirs[++num]=strdup(direntp->d_name);
	       errno=0;
	       titel[num][0]=0;
	       paintrec[num][0]=0;
	       grouprec[num][0]=0;
	       if (errno==EISDIR) isdir[num]=1; else isdir[num]=0;	 
// Here.
	       stat(direntp->d_name, &stats);
	       if(stats.st_mode&S_IFDIR)
	          isdir[num]=1;
	       else  {
	          isdir[num]=0;
	          fp=fopen(direntp->d_name,"rb");
	          fseek(fp,-128,SEEK_END);
	          fread(&Tmp.id,5,1,fp);
	          if ((Tmp.id[0]=='S')&(Tmp.id[1]=='A')&
		      (Tmp.id[2]=='U')&(Tmp.id[3]=='C')&(Tmp.id[4]=='E')) {
		     fread(&Tmp.Version,2,1,fp);
		     fread(&Tmp.Title,1,35,fp);
		     sprintf(titel[num],"%-27s",Tmp.Title);
		     titel[num][27]=0;
		     fread(&Tmp.Author,1,20,fp);
		     sprintf(paintrec[num],"%-17s",Tmp.Author);	    
		     paintrec[num][17]=0;
		     fread(&Tmp.Group,1,20,fp);
		     sprintf(grouprec[num],"%-14s",Tmp.Group);
		     grouprec[num][14]=0;
		     fclose(fp);
		  }
	       }
	    }
	 }
	 closedir(dirp);
      }
      for (x=0;x<=8;x++) 
	if (dirs[1+x+z]!=NULL&&1+x+z<=num) {
	   if (y==x) TextColor(15+16); else TextColor(15);
	   if (isdir[1+x+z]==1) 
	     if (y==x) TextColor(7+16); else TextColor(7);
	   move(13+x,2);
	   write("%-12s",dirs[1+x+z]);
	   move(13+x,14);
	   writechar(' ');
	   if (isdir[1+x+z]==0) {	      
	      if (y==x) TextColor(7+16); else TextColor(7);
	      writechar(250);
	      if (y==x) TextColor(15+16); else TextColor(15);
	      write(" %-27s",titel[1+x+z]);
	      if (y==x) TextColor(7+16); else TextColor(7);
	      writechar(250);
	      if (y==x) TextColor(15+16); else TextColor(15);
	      write(" %-17s",paintrec[1+x+z]);
	      if (y==x) TextColor(7+16); else TextColor(7);
	      writechar(250);
	      if (y==x) TextColor(15+16); else TextColor(15);
	      write(" %-14s",grouprec[1+x+z]);
	   } else {
	      if (y==x) TextColor(8+16); else TextColor(8);
	      write(" <DiRECTORY>                                                    ");
	   }   
	} else { 
	   TextColor(7);
	   move(13+x,2);
	   write("                                                                             ");
	}      
      ch=newgetch();
      switch(ch){
       case 13:
	 if (isdir[1+y+z]==1) {
	    chdir(dirs[1+y+z]);
	    readnew=1;
	 } else {
	    LoadFile(dirs[1+y+z]);
	    ch=27;
	 }	 
	 break;
       case KEY_PPAGE:
	 y=0;
	 z-=8;
	 if (z<0) z=0;	 
	 break;
       case KEY_NPAGE:
	 y=8;
	 z+=8;
	 if (z+9>num) z=num-9;	
	 if (y+1>num){
	    y=num-1;
	    z=0;
	 }	 
	 break;
       case KEY_UP:
	 y--;
	 if (y<0) {
	    y=0;
	    if (z>0) z--;
	 }	 
	 break;
       case KEY_DOWN:
	 y++;
	 if (y>8) {
	    y=8;
	    if (z+9<num) z++;
	 }	 
	 if (y+1>num) y=num-1;
	 break;	 
      }      
   } while (ch!=27);
}
