char nul[100];

void CopyScreen(int p1,int p2)  {
   int x;
   for (x=0;x<MaxLines;x++)  
      memcpy(Screen[p2][x],Screen[p1][x],160);
}
void SaveScreen() {
   CopyScreen(ActivePage,UNDOPage);
/*   
   memcpy(&Screen[UNDOPage][0][0],
	  &Screen[ActivePage][0][0],MaxLines*160);*/
   
}

void InsLine() {
   int a,b;
   for (b=MaxLines-1;b>CursorY+FirstLine;b--)
     memcpy(Screen[ActivePage][b],Screen[ActivePage][b-1],160);
   for (b=0;b<80;b++) {
      Screen[ActivePage][CursorY+FirstLine][b*2]=32;
      Screen[ActivePage][CursorY+FirstLine][b*2+1]=7;
   }
   if (LastLine<MaxLines) LastLine++;
}

void DelLine() {
   int a,b;
   for (b=CursorY+FirstLine;b<MaxLines;b++)
     memcpy(Screen[ActivePage][b],Screen[ActivePage][b+1],160);
   for (b=0;b<80;b++) {
      Screen[ActivePage][MaxLines-1][b<<1]=32;
      Screen[ActivePage][MaxLines-1][(b<<1)+1]=7;
   }
   if (LastLine>CursorY+FirstLine) LastLine--;
}

void InsCol(void) {
   int a,b;
   for (a=0;a<MaxLines;a++) {
      memmove(&Screen[ActivePage][a][(CursorX<<1)],
	      &Screen[ActivePage][a][(CursorX<<1)-2],160-(CursorX<<1));
      Screen[ActivePage][a][CursorX<<1]=32;
      Screen[ActivePage][a][(CursorX<<1)+1]=7;
   }
}
void DelCol(void) {
   int a,b;
   for (a=0;a<MaxLines;a++) {
      memmove(&Screen[ActivePage][a][(CursorX<<1)],
	      &Screen[ActivePage][a][(CursorX<<1)+2],160-(CursorX<<1));
      Screen[ActivePage][a][158]=32;
      Screen[ActivePage][a][159]=7;
   }
}

void Colors(unsigned char col) {
   if (FullScreen==TRUE) return;
   move(0,10);
   TextColor(col);
   write(" Color ");	
}

void CoolWrite(char * a) {
   int x=0,i=0;
   while (a[x]!=0) {
      i++;
      if (a[x]==32) i=0;
      switch (i) {
       case 1:
         TextColor(8);
         break;
       case 3:
       case 2:
         TextColor(3);
         break;
       default:
         TextColor(11);
         break;
      }
      writechar(a[x++]);
   }
}
void CodeWrite(char * a) {
   int x=0;
   TextColor(15);
   while (a[x]!=0) {
      if (a[x]==']') TextColor(15);
      writechar(a[x]);
      if (a[x]=='[') TextColor(7);
      x++;
   }
}

unsigned char SelectColor()
     {
	int Blink,x,a,ch;
	for (x=1;x<=1400;x++)
	  {
	     if ((x%160<125)&&(x%160>2))
	       {
		  if (x%2==0)
		    {
		       move(15+x/160,11+(x%160)/2);
		       if (RahmenAnsi[x]==0) RahmenAnsi[x]=32;
		       writechar(RahmenAnsi[x]);
		    } else TextColor(RahmenAnsi[x]);
	       }
	  }
	move(21,38);
	write("B - BLINK");
	move(17,19);
	TextColor(15);
	writechar(176);
	writechar(176);
	writechar(32);
	for (a=1;a<=15;a++)
	  {
	     TextColor(a);
	     writechar(219);
	     writechar(219);
	     writechar(32);
	  }
	move(19,30);
	TextColor(15);
	writechar(176);
	writechar(176);
	writechar(32);
	for (a=1;a<=7;a++)
	  {
	     TextColor(a);
	     writechar(219);
	     writechar(219);
	     writechar(32);
	  }
	x=19+((Attribute&15)*3);
	Blink=Attribute&128;
	do
	  {
	     TextColor(14);
	     move(16,x);
	     writechar(194);
	     writechar(194);
	     move(18,x);
	     writechar(193);
	     writechar(193);
	     Colors((Attribute&112)+(x-19)/3+Blink);
	     TextColor(14);
	     ch=newgetch();
	     move(16,x);
	     writechar(32);
	     writechar(32);
	     move(18,x);
	     writechar(32);
	     writechar(32);
	     switch (ch)
	       {
		case 98:
		case 66:
		  Blink=Blink^128;
		  break;
		case KEY_LEFT:
		  x-=3;
		  break;
		case KEY_RIGHT:
		  x+=3;
		  break;
	       }
	     if (x>64) x=19;
	     if (x<19) x=64;
	  } while (ch!=13);
	a=(x-19)/3;
	x=30+((Attribute & 112)>>4)*3;
	do
	  {
	     TextColor(14);
	     move(18,x);
	     writechar(194);
	     writechar(194);
	     move(20,x);
	     writechar(193);
	     writechar(193);
	     Colors(a+(((x-30)/3)<<4)+Blink);
	     TextColor(14);
	     ch=newgetch();
	     move(18,x);
	     writechar(32);
	     writechar(32);
	     move(20,x);
	     writechar(32);
	     writechar(32);
	     switch (ch)
	       {
		case 98:
		case 66:
		  Blink=Blink^128;
		  break;
		case KEY_LEFT:
		  x-=3;
		  break;
		case KEY_RIGHT:
		  x+=3;
		  break;
	       }
	     if (x>51) x=30;
	     if (x<30) x=51;
	  } while (ch!=13);
	return (a+(((x-30)/3)<<4)+Blink);
     }
char translate(char a){
   switch(a) {
    case 'e':
      return '';
      break;
    case 'E':
      return '';
      break;
    case 'I':
      return '';
      break;
    case 'r':
      return '';
      break;  
    case 'R':
      return '';
    case 'F':
    case 'f':
      return '';
    case 'a':
      return '';
    case 'A':
      return '';
    case 'b':
    case 'B':
      return '';
    case 'n':
    case 'N':
      return '';
    case 'u':
      return 150;
    case 'U':
      return '';
    case 'Y':
      return '';
    case 'o':
      return '';
    case 'O':
      return '';   
    case 'L':
    case 'l':
      return '';
    case 'X':
    case 'x':
      return '';
    case 'S':
    case 's':
      return '$';
    case 'C':
    case 'c':
      return '';
    case 'D':
    case 'd':
      return '';
    case 'y':
      return '';
    case 't':
      return '';
    default:
      return a;
   }
}
char *inputfield(char *Str,int length,int x1,int y) {
   int ch,x,pos=0;
   char ins=FALSE;
   move(y,x1);
   TextColor(8);
   for (x=1;x<=length;x++) writechar(250);
   move(y,x1);
   TextColor(7);
   sprintf(nul,"%s",Str);
   move(y,x1);
   write("%s",nul);
   do {
      move(y,x1+pos);
      ch=newgetch();
      switch (ch) {
       case ERR:
	 break;
       case KEY_LEFT:
	 if (pos>0) pos--;
	 break;
       case KEY_RIGHT:
	 if (pos<strlen(nul)) pos++;
	 break;
       case 262:
	 pos=0;
	 break;
       case 360:
	 pos=strlen(nul);
	 break;
       case 330:
	 if (pos!=strlen(nul)) {
	    memcpy(&nul[pos],&nul[pos+1],200-pos);
	    move(y,x1);
	    write("%s",nul);
	    TextColor(8);writechar(250);TextColor(7);
	    move(y,x1+pos);
	 }
	 break;
       case 263:
       case 127:
	 if (pos>0) {   
	    memcpy(&nul[pos-1],&nul[pos],200-pos);
	    pos--;
	    move(y,x1);
	    write("%s",nul);
	    TextColor(8);writechar(250);TextColor(7);
	    move(y,x1+pos);
	 }
	 break;
       default:
	 if ((pos<length)&(ch>=32)&(ch<=127)) {
	    if (pos==strlen(nul))
	    sprintf(nul,"%s%c",nul,(ch&255)); else nul[pos]=ch;
	    move(y,x1);
	    write("%s",nul);
	    TextColor(7);
	    pos++;
	 }
	 break;
      }      
   } while ((ch!=13)&(ch!=27));
   if (ch==27) return Str;
   return nul;
}
void about() {
   do {
   } while (getch()!=ERR);
   DrawBox(29,10,61,15);
   move(11,30);
   CoolWrite("coded 1996 by Mike Krueger     ");
   move(12,30);
   CoolWrite("ansis made by Col. Blair^TUSCON");
   move(13,30);
   CoolWrite("Fixes/Changes by Stephen Hurd  ");
   move(14,30);
   CoolWrite("Version 1.5 (GPL)              ");
   do {
   } while (getch()==ERR);
}
